schedule function bastion_raid:2s 2s

#PIGLINS PROTECT PLAYERS FROM MOBS
execute as @e[type=#bastion_raid:piglins,tag=bastion_raid.piglins,predicate=!bastion_raid:angry,nbt=!{IsBaby:1b},limit=10,sort=random] at @s run execute if entity @e[type=!player,type=!#bastion_raid:piglins,tag=!bastion_raid.piglins,team=!piglin,distance=..16,predicate=bastion_raid:angryat/hero,nbt=!{Invulnerable:1b}] run function bastion_raid:protect/1

#PIGLINS PROTECT PLAYERS FROM BAD_HOGS
execute as @e[type=#bastion_raid:piglins,tag=bastion_raid.piglins,predicate=!bastion_raid:angry,nbt=!{IsBaby:1b},limit=10,sort=random] at @s run execute if entity @e[type=hoglin,tag=bastion_raid.bad_hog,team=!piglin,distance=..16,nbt=!{Invulnerable:1b}] run execute if entity @a[gamemode=!creative,gamemode=!spectator,advancements={bastion_raid:hero=true},distance=..16] run function bastion_raid:protect/2

#PIGLINS PROTECT PLAYERS FROM SMITHED PIGLINS
execute as @e[type=#bastion_raid:piglins,tag=bastion_raid.piglins,predicate=!bastion_raid:angry,nbt=!{IsBaby:1b},limit=10,sort=random] at @s run execute if entity @e[type=#bastion_raid:piglins,distance=..16,tag=!bastion_raid.piglins,team=!piglin,predicate=bastion_raid:angryat/hero,nbt=!{Invulnerable:1b}] run function bastion_raid:protect/3

#TAG ADD PIGLINS
execute as @e[type=#bastion_raid:piglins,tag=bastion_raid.piglins,tag=!bastion_raid.target,predicate=bastion_raid:location/bastion,nbt=!{IsBaby:1b}] at @s run execute if entity @e[type=#bastion_raid:piglins,tag=bastion_raid.piglins,tag=bastion_raid.target,predicate=bastion_raid:location/bastion,distance=..5] run tag @s add bastion_raid.target

#WITHER CURSED PLAYERS IN BASTION
execute as @a[gamemode=!spectator,scores={bastion_raid.cur=1..},predicate=bastion_raid:location/bastion] at @s run execute if entity @e[type=#bastion_raid:piglins,predicate=bastion_raid:location/bastion,tag=bastion_raid.piglins,distance=..64] run function bastion_raid:bossbar/start

#WITHER SKELETON ANGER
execute as @e[type=wither_skeleton,limit=4,team=bastion_raid,predicate=!bastion_raid:angry,sort=random] at @s run execute if entity @e[type=#bastion_raid:piglins,tag=bastion_raid.target,distance=..64] run summon minecraft:snowball ~ ~2.71 ~ {Item:{id:"minecraft:warped_button",Count:1b},Tags:["bastion_raid.trigger"]}
execute as @e[type=snowball,tag=bastion_raid.trigger] at @s run data modify entity @s Owner set from entity @e[tag=bastion_raid.target,sort=nearest,limit=1] UUID

#CONVERT FROM RAIDER TO NORMAL
execute as @e[type=wither_skeleton,tag=bastion_raid.raider] at @s run execute unless score bastion_raid.sc bastion_raid.vis matches 1 run tag @s remove bastion_raid.raider